<?php
/*
Plugin Name: WebDev AJAX
Plugin URI: http://#
Description: Quick AJAX Tutorial
Version: 0.1a
Author: Anonymous
Author URI: http://#
Reference: https://webdevstudios.com/2015/02/12/handling-ajax-in-wordpress/
*/

class Proofreading_Ajax_Handler {
	
	function hooks(){
		add_action( 'wp_ajax_analyze', array( $this, 'handle_ajax_analyze' ) );
		//add_action( 'wp_ajax_nopriv_analyze', array( $this, 'handle_ajax_analyze' ) );
		
		add_action( 'wp_ajax_select_lang_rules', array( $this, 'handle_select_lang_rules' ) );
		
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
	}
	
	function handle_ajax_analyze() {
		if( ! wp_verify_nonce( $_REQUEST['nonce'], 'webdev' ) ){
			wp_send_json_error();
		}
		
		require_once plugin_dir_path( __FILE__ ) . 'class-languagetool.php';
		$lt = new LanguageTool();
		
		global $wpdb;
		$included_rules = $wpdb->get_var("SELECT `included_rules` FROM {$wpdb->prefix}proofreading_rules_settings WHERE lang_code = '" . $_REQUEST['language'] . "'");
		
		$body = $lt->check($_REQUEST['post_text'], $_REQUEST['language'], $included_rules);
		
		wp_send_json_success( array(
			'result' 		  => json_encode($body),
			'nonce'           => wp_create_nonce( 'webdev' ),
		) );
	}
	
	public function handle_select_lang_rules($code) {
		if( ! wp_verify_nonce( $_REQUEST['nonce'], 'webdev' ) ){
			wp_send_json_error();
		}
		
		global $wpdb;
		$result = array();
		
		$lang = esc_sql($_POST['lang_code']);
		
		$rules = $wpdb->get_results("SELECT `name`, `key`
			FROM {$wpdb->prefix}proofreading_rules
			WHERE lang_code = '$lang'
			ORDER BY `name` ASC", ARRAY_A);
			
		$included_rules = $wpdb->get_var("SELECT `included_rules` FROM {$wpdb->prefix}proofreading_rules_settings
			WHERE lang_code = '$lang'");
		
		$rules_included_keys = array();
		if ($included_rules != null){
			$rules_included_keys = explode(',', $included_rules);
		}
		
		for ( $i = 0; $i < count($rules); $i++ )
			if ( in_array($rules[$i]['key'], $rules_included_keys) || (count($included_rules) == 0) )
				$rules[$i]['included'] = 1;
			else
				$rules[$i]['included'] = 0;
		
		$result['success'] = true;
		$result['data'] = array();
		$result['data']['result'] = $rules;
		
		echo json_encode($result);
		wp_die();
	}
	
	function enqueue_scripts() {
		wp_enqueue_script( 'webdev_js', plugins_url( '../js/proofreading-ajax.js', __FILE__ ), array( 'jquery' ), '1.0', true );
		wp_localize_script( 'webdev_js', 'proofreading', array(
			//'ajax_url' => admin_url( 'admin-ajax.php' ),
			'nonce'	   => wp_create_nonce( 'webdev' ),
			'trans_result_ok' => __('Your text is OK', 'proofreading'),
			'trans_result_errors_to_correct' => __('ERRORS to correct', 'proofreading'),
			'trans_result_errors_hidden' => __('Hidden errors', 'proofreading'),
			'trans_result_error' => __('Translation ERROR', 'proofreading'),
			'trans_result_error_too_many_errors' => __('Too many errors. Did you select the right language?', 'proofreading'),
			'trans_result_error_invalid_request' => __('Invalid request to Proofreading check service', 'proofreading'),
			'trans_btn_show_error' => __('Show error in the text', 'proofreading'),
			'trans_btn_hide_error' => __('Hide error', 'proofreading'),
			'trans_btn_hide_error_category' => __('Hide all errors in this category', 'proofreading'),
			'trans_btn_show_error_hidden' => __('Show hidden errors', 'proofreading')
		) );
		
	}
	
}

$proofreadingAjax = new Proofreading_Ajax_Handler();
$proofreadingAjax->hooks();