<?php
require_once plugin_dir_path( __FILE__ ) . 'scribit_custom_field.php';
 
class ProofreadingMetaBox {
     
    public $parameters = array();
    protected $_cf;
     
    public function __construct( ) {
		
        $this->parameters = array(
			'id' => 'proofreading_box',
			'title' => __('Proofreading'),
			'screen' => array('post', 'page'),
			'context' => 'normal',
			'priority' => 'high'
		);
		
		$this->loadFields();
		
		include_once plugin_dir_path( __FILE__ ) . 'class-ajax-handler.php';
    }
     
    public function loadFields() {
		
		global $wpdb;
		$fields = array();
		
		$languages = $wpdb->get_results("SELECT name AS label, longCode AS value
			FROM {$wpdb->prefix}proofreading_languages
			WHERE active = 1", ARRAY_A);

		$this->fields[] = array(
			'name' => 'language',
			'id' => 'language',
			'class' => 'language_selection',
			'type' => 'select',
			'options' => $languages,
			'value' => get_option('proofreading-language-default'),
			'allow_empty' => false
		);
		
		$this->fields[] = array(
			'url' => '../wp-content/plugins/proofreading/admin/img/language.png',
			'type' => 'image',
			'style' => 'float:right;margin:4px 4px 0 4px;'
		);
		
		$this->fields[] = array(
			'name' => 'proofreading_analyze',
			'id' => 'proofreading_analyze',
			'class' => 'analyze_button',
			'type' => 'button',
			'label' => __( 'Analyze', 'proofreading' )
		);
		
		$this->fields[] = array(
			'id' => 'proofreading_analyze_results',
			'type' => 'div',
			'label' => ''
		);
		
        $this->_cf = new ScribitCustomField( $this->parameters, $this->fields ); 
		
    }
	
}

?>