(function( $ ) {
	'use strict';

	$( document ).ready(function() {
	
		// Settings page
		if ($('.proofreading-settings').length){
			
			$('#select_all_rules').change(function() {
				if(this.checked)
					$('.rule').each(function(){ $(this).prop('checked', 'checked') });
				else
					$('.rule').each(function(){ $(this).prop('checked', '') });
			});
			
			loadLanguageRules($('#proofreading-language-rules-settings').val());
			
			$('#proofreading-language-rules-settings').change(function() {
				loadLanguageRules($(this).val());
			});

			function loadLanguageRules(lang_code) {
				var post_data = {
					action	   : 'select_lang_rules',
					nonce      : proofreading.nonce,
					lang_code  : lang_code
				};
				
				$.post(
					ajaxurl,
					post_data,
					function( response ){
						
						if( response.success ){
							var html = '';
							if (response.data.result.length == 0 || response.data.error != null)
							{
								$('.select_all_rules_row').hide();
								html += '<tr><td>No rules</td></tr>';
							}
							else{
								$('.select_all_rules_row').show();
								for(var i = 0; i < response.data.result.length; i++){
									var rule = response.data.result[i];
									html += '<tr><td><label for="'+ rule.key + '"><input type="checkbox" class="rule" id="'+ rule.key + '" name="rules[]" value="'+ rule.key + '"';
									if (rule.included) html += ' checked = "checked"';
									html += '> '+ rule.name + '</label></td></tr>';
								}
							}
							$('.rules_container').html(html);
							
						} else {
							app.$analyze_result.html('<p class="error">Generic error</p>');
						}
					},
					'json');
			};
			
		}
			
		$('.hide_correction').on('click', function(){
			alert(0);
		});
			
		$('.hide_correction').click(function(){
			alert(1);
		});
	});

})( jQuery );